RABCDAsm Changelog
==================

RABCDAsm v1.8 (2011.07.06)
--------------------------

 * Fixed handling of orphan methods with multiple references
 * Treat out-of-bounds namespace/multiname indices as null
 * Documentation updates

RABCDAsm v1.7 (2011.06.14)
--------------------------

 * Fixed handling of invalid UTF-8 in strings
 * Fixed handling of null namespaces and multinames
 * Fixed handling of exception info in corrupted method bodies
 * Fixed handling of orphan private namespaces
 * Fixed handling of out-of-bounds class/method indices
 * Disassembler now creates one file per class and script-level method
 * Disassembler now outputs blank lines after `si32` etc. instructions as well
 * `abcexport` now delimits the index with a dash in output filenames
 * Improved shortening of `double` literals
 * Documentation updates

RABCDAsm v1.6 (2011.05.13)
--------------------------

 * Overhaul of the structure of disassembler-generated files
   * Private namespace names and `refid`s for nested classes are now generated
     from their referenced contexts
     * This also fixes problems caused by private namespaces being referenced
       in multiple distinct contexts
   * One `#include`d file per script instead of per class
     * Nested classes, script initializers and other script traits are now in
       the same file as their main class
   * Inline methods are now in separate files, placed according to their usage
     context
   * Private namespaces are sorted by their autogenerated names in the
     `.privatens.asasm` file
   * No syntax changes, output is backwards-compatible
 * Improved escaping of file names
 * Output correct opcode error locations
 * Disassembler will now refuse to overwrite files
 * `rabcdasm` will now always generate output in the same directory as the
   input file
 * Failure to decode a method body is now not a fatal error
 * Aggressively try to shorten double literals to their shortest representation
 * Added the `swfbinexport` and `swfbinreplace` utilities, to aid in manipulating
   contents of `DefineBinaryData` tags
 * The package can now be built using a simple, dedicated build tool
 * Documentation updates

RABCDAsm v1.5 (2011.04.14)
--------------------------

 * Fixed v1.4 constant pool regression
 * Added support for memory-access and sign-extend opcodes
 * Speed optimizations
 * Documentation updates

RABCDAsm v1.4 (2011.03.07)
--------------------------

 * Source code ported to D2
 * Add support for forward-references for TypeName-kind Multinames
 * Correctly order classes by dependencies (extends/implements) and reference
   count
 * Finish Metadata support
 * Documentation updates

RABCDAsm v1.3 (2010.11.11)
--------------------------

 * Fixed double precision problem
   * This also fixes problems with illegal default values for function
     parameters (default values for integer parameters are stored as doubles, 
     which might become out-of-range due to inadequate double precision)
 * Added Changelog
 * Documentation markdown fixes

RABCDAsm v1.2 (2010.11.06)
--------------------------

 * Fixed ref generation for orphan objects which were only referenced
   by other orphans
 * Better error handling in `abcexport`; warn when no DoABC tags found
 * Documentation updates

RABCDAsm v1.1 (2010.06.30)
--------------------------

 * Private namespaces are now referenced by auto-generated names
 * Use `:` to delimit namespace and name in QNames for consistency
 * Fixed relative include paths
 * Add optional byte offsets to labels, which allows lossless representation
   of jumps inside instructions and outside the function bounds
 * Documentation updates

RABCDAsm v1.0 (2010.05.05)
--------------------------

 * Initial release.
